


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/krb5/gssapi.py: 70%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/krb5/gssapi.py</b> :
            <span class="pc_cov">70%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            163 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">115 run</span>
            <span class="mis shortkey_m button_toggle_mis">48 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">6 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="stm run hide_run"><a href="#n15">15</a></p>
<p id="n16" class="stm run hide_run"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm mis"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="pln"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm run hide_run"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="stm run hide_run"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm run hide_run"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="pln"><a href="#n42">42</a></p>
<p id="n43" class="stm run hide_run"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="stm run hide_run"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="stm run hide_run"><a href="#n56">56</a></p>
<p id="n57" class="stm run hide_run"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="stm run hide_run"><a href="#n63">63</a></p>
<p id="n64" class="stm par run hide_run"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="stm par run hide_run"><a href="#n66">66</a></p>
<p id="n67" class="stm mis"><a href="#n67">67</a></p>
<p id="n68" class="stm par run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="stm run hide_run"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm run hide_run"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="pln"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="pln"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="stm run hide_run"><a href="#n86">86</a></p>
<p id="n87" class="stm run hide_run"><a href="#n87">87</a></p>
<p id="n88" class="pln"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="pln"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="pln"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="stm run hide_run"><a href="#n97">97</a></p>
<p id="n98" class="stm run hide_run"><a href="#n98">98</a></p>
<p id="n99" class="stm run hide_run"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="stm run hide_run"><a href="#n102">102</a></p>
<p id="n103" class="stm run hide_run"><a href="#n103">103</a></p>
<p id="n104" class="stm run hide_run"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="stm run hide_run"><a href="#n106">106</a></p>
<p id="n107" class="stm par run hide_run"><a href="#n107">107</a></p>
<p id="n108" class="stm run hide_run"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="stm mis"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="stm run hide_run"><a href="#n112">112</a></p>
<p id="n113" class="stm run hide_run"><a href="#n113">113</a></p>
<p id="n114" class="stm run hide_run"><a href="#n114">114</a></p>
<p id="n115" class="stm run hide_run"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="stm run hide_run"><a href="#n117">117</a></p>
<p id="n118" class="stm run hide_run"><a href="#n118">118</a></p>
<p id="n119" class="stm run hide_run"><a href="#n119">119</a></p>
<p id="n120" class="stm run hide_run"><a href="#n120">120</a></p>
<p id="n121" class="stm run hide_run"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="stm run hide_run"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="pln"><a href="#n126">126</a></p>
<p id="n127" class="pln"><a href="#n127">127</a></p>
<p id="n128" class="stm run hide_run"><a href="#n128">128</a></p>
<p id="n129" class="stm run hide_run"><a href="#n129">129</a></p>
<p id="n130" class="pln"><a href="#n130">130</a></p>
<p id="n131" class="pln"><a href="#n131">131</a></p>
<p id="n132" class="stm run hide_run"><a href="#n132">132</a></p>
<p id="n133" class="stm run hide_run"><a href="#n133">133</a></p>
<p id="n134" class="stm run hide_run"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="stm run hide_run"><a href="#n136">136</a></p>
<p id="n137" class="stm run hide_run"><a href="#n137">137</a></p>
<p id="n138" class="pln"><a href="#n138">138</a></p>
<p id="n139" class="stm par run hide_run"><a href="#n139">139</a></p>
<p id="n140" class="stm run hide_run"><a href="#n140">140</a></p>
<p id="n141" class="pln"><a href="#n141">141</a></p>
<p id="n142" class="stm mis"><a href="#n142">142</a></p>
<p id="n143" class="pln"><a href="#n143">143</a></p>
<p id="n144" class="pln"><a href="#n144">144</a></p>
<p id="n145" class="stm run hide_run"><a href="#n145">145</a></p>
<p id="n146" class="pln"><a href="#n146">146</a></p>
<p id="n147" class="stm run hide_run"><a href="#n147">147</a></p>
<p id="n148" class="stm run hide_run"><a href="#n148">148</a></p>
<p id="n149" class="pln"><a href="#n149">149</a></p>
<p id="n150" class="stm run hide_run"><a href="#n150">150</a></p>
<p id="n151" class="stm run hide_run"><a href="#n151">151</a></p>
<p id="n152" class="stm run hide_run"><a href="#n152">152</a></p>
<p id="n153" class="stm run hide_run"><a href="#n153">153</a></p>
<p id="n154" class="pln"><a href="#n154">154</a></p>
<p id="n155" class="stm run hide_run"><a href="#n155">155</a></p>
<p id="n156" class="stm run hide_run"><a href="#n156">156</a></p>
<p id="n157" class="pln"><a href="#n157">157</a></p>
<p id="n158" class="stm run hide_run"><a href="#n158">158</a></p>
<p id="n159" class="pln"><a href="#n159">159</a></p>
<p id="n160" class="stm run hide_run"><a href="#n160">160</a></p>
<p id="n161" class="pln"><a href="#n161">161</a></p>
<p id="n162" class="stm run hide_run"><a href="#n162">162</a></p>
<p id="n163" class="stm run hide_run"><a href="#n163">163</a></p>
<p id="n164" class="pln"><a href="#n164">164</a></p>
<p id="n165" class="stm run hide_run"><a href="#n165">165</a></p>
<p id="n166" class="pln"><a href="#n166">166</a></p>
<p id="n167" class="stm run hide_run"><a href="#n167">167</a></p>
<p id="n168" class="stm run hide_run"><a href="#n168">168</a></p>
<p id="n169" class="stm run hide_run"><a href="#n169">169</a></p>
<p id="n170" class="stm run hide_run"><a href="#n170">170</a></p>
<p id="n171" class="pln"><a href="#n171">171</a></p>
<p id="n172" class="stm run hide_run"><a href="#n172">172</a></p>
<p id="n173" class="stm run hide_run"><a href="#n173">173</a></p>
<p id="n174" class="pln"><a href="#n174">174</a></p>
<p id="n175" class="stm run hide_run"><a href="#n175">175</a></p>
<p id="n176" class="pln"><a href="#n176">176</a></p>
<p id="n177" class="stm run hide_run"><a href="#n177">177</a></p>
<p id="n178" class="stm run hide_run"><a href="#n178">178</a></p>
<p id="n179" class="stm run hide_run"><a href="#n179">179</a></p>
<p id="n180" class="stm run hide_run"><a href="#n180">180</a></p>
<p id="n181" class="stm par run hide_run"><a href="#n181">181</a></p>
<p id="n182" class="stm run hide_run"><a href="#n182">182</a></p>
<p id="n183" class="stm run hide_run"><a href="#n183">183</a></p>
<p id="n184" class="stm run hide_run"><a href="#n184">184</a></p>
<p id="n185" class="pln"><a href="#n185">185</a></p>
<p id="n186" class="stm mis"><a href="#n186">186</a></p>
<p id="n187" class="pln"><a href="#n187">187</a></p>
<p id="n188" class="stm run hide_run"><a href="#n188">188</a></p>
<p id="n189" class="stm run hide_run"><a href="#n189">189</a></p>
<p id="n190" class="pln"><a href="#n190">190</a></p>
<p id="n191" class="stm run hide_run"><a href="#n191">191</a></p>
<p id="n192" class="stm run hide_run"><a href="#n192">192</a></p>
<p id="n193" class="pln"><a href="#n193">193</a></p>
<p id="n194" class="stm run hide_run"><a href="#n194">194</a></p>
<p id="n195" class="stm run hide_run"><a href="#n195">195</a></p>
<p id="n196" class="stm run hide_run"><a href="#n196">196</a></p>
<p id="n197" class="pln"><a href="#n197">197</a></p>
<p id="n198" class="stm run hide_run"><a href="#n198">198</a></p>
<p id="n199" class="stm run hide_run"><a href="#n199">199</a></p>
<p id="n200" class="pln"><a href="#n200">200</a></p>
<p id="n201" class="pln"><a href="#n201">201</a></p>
<p id="n202" class="pln"><a href="#n202">202</a></p>
<p id="n203" class="pln"><a href="#n203">203</a></p>
<p id="n204" class="pln"><a href="#n204">204</a></p>
<p id="n205" class="pln"><a href="#n205">205</a></p>
<p id="n206" class="pln"><a href="#n206">206</a></p>
<p id="n207" class="pln"><a href="#n207">207</a></p>
<p id="n208" class="pln"><a href="#n208">208</a></p>
<p id="n209" class="stm run hide_run"><a href="#n209">209</a></p>
<p id="n210" class="stm run hide_run"><a href="#n210">210</a></p>
<p id="n211" class="pln"><a href="#n211">211</a></p>
<p id="n212" class="pln"><a href="#n212">212</a></p>
<p id="n213" class="pln"><a href="#n213">213</a></p>
<p id="n214" class="pln"><a href="#n214">214</a></p>
<p id="n215" class="pln"><a href="#n215">215</a></p>
<p id="n216" class="pln"><a href="#n216">216</a></p>
<p id="n217" class="pln"><a href="#n217">217</a></p>
<p id="n218" class="pln"><a href="#n218">218</a></p>
<p id="n219" class="stm run hide_run"><a href="#n219">219</a></p>
<p id="n220" class="stm mis"><a href="#n220">220</a></p>
<p id="n221" class="pln"><a href="#n221">221</a></p>
<p id="n222" class="pln"><a href="#n222">222</a></p>
<p id="n223" class="stm mis"><a href="#n223">223</a></p>
<p id="n224" class="stm mis"><a href="#n224">224</a></p>
<p id="n225" class="stm mis"><a href="#n225">225</a></p>
<p id="n226" class="pln"><a href="#n226">226</a></p>
<p id="n227" class="stm mis"><a href="#n227">227</a></p>
<p id="n228" class="pln"><a href="#n228">228</a></p>
<p id="n229" class="stm mis"><a href="#n229">229</a></p>
<p id="n230" class="stm mis"><a href="#n230">230</a></p>
<p id="n231" class="stm mis"><a href="#n231">231</a></p>
<p id="n232" class="pln"><a href="#n232">232</a></p>
<p id="n233" class="stm mis"><a href="#n233">233</a></p>
<p id="n234" class="pln"><a href="#n234">234</a></p>
<p id="n235" class="stm run hide_run"><a href="#n235">235</a></p>
<p id="n236" class="stm mis"><a href="#n236">236</a></p>
<p id="n237" class="stm mis"><a href="#n237">237</a></p>
<p id="n238" class="stm mis"><a href="#n238">238</a></p>
<p id="n239" class="stm mis"><a href="#n239">239</a></p>
<p id="n240" class="pln"><a href="#n240">240</a></p>
<p id="n241" class="stm run hide_run"><a href="#n241">241</a></p>
<p id="n242" class="stm mis"><a href="#n242">242</a></p>
<p id="n243" class="stm mis"><a href="#n243">243</a></p>
<p id="n244" class="stm mis"><a href="#n244">244</a></p>
<p id="n245" class="pln"><a href="#n245">245</a></p>
<p id="n246" class="stm run hide_run"><a href="#n246">246</a></p>
<p id="n247" class="stm mis"><a href="#n247">247</a></p>
<p id="n248" class="pln"><a href="#n248">248</a></p>
<p id="n249" class="stm mis"><a href="#n249">249</a></p>
<p id="n250" class="pln"><a href="#n250">250</a></p>
<p id="n251" class="pln"><a href="#n251">251</a></p>
<p id="n252" class="stm mis"><a href="#n252">252</a></p>
<p id="n253" class="stm mis"><a href="#n253">253</a></p>
<p id="n254" class="stm mis"><a href="#n254">254</a></p>
<p id="n255" class="pln"><a href="#n255">255</a></p>
<p id="n256" class="pln"><a href="#n256">256</a></p>
<p id="n257" class="pln"><a href="#n257">257</a></p>
<p id="n258" class="stm mis"><a href="#n258">258</a></p>
<p id="n259" class="pln"><a href="#n259">259</a></p>
<p id="n260" class="stm mis"><a href="#n260">260</a></p>
<p id="n261" class="stm mis"><a href="#n261">261</a></p>
<p id="n262" class="stm mis"><a href="#n262">262</a></p>
<p id="n263" class="stm mis"><a href="#n263">263</a></p>
<p id="n264" class="pln"><a href="#n264">264</a></p>
<p id="n265" class="stm mis"><a href="#n265">265</a></p>
<p id="n266" class="stm mis"><a href="#n266">266</a></p>
<p id="n267" class="pln"><a href="#n267">267</a></p>
<p id="n268" class="stm mis"><a href="#n268">268</a></p>
<p id="n269" class="pln"><a href="#n269">269</a></p>
<p id="n270" class="pln"><a href="#n270">270</a></p>
<p id="n271" class="stm mis"><a href="#n271">271</a></p>
<p id="n272" class="stm mis"><a href="#n272">272</a></p>
<p id="n273" class="pln"><a href="#n273">273</a></p>
<p id="n274" class="stm mis"><a href="#n274">274</a></p>
<p id="n275" class="pln"><a href="#n275">275</a></p>
<p id="n276" class="stm run hide_run"><a href="#n276">276</a></p>
<p id="n277" class="stm mis"><a href="#n277">277</a></p>
<p id="n278" class="pln"><a href="#n278">278</a></p>
<p id="n279" class="stm mis"><a href="#n279">279</a></p>
<p id="n280" class="stm mis"><a href="#n280">280</a></p>
<p id="n281" class="pln"><a href="#n281">281</a></p>
<p id="n282" class="stm mis"><a href="#n282">282</a></p>
<p id="n283" class="pln"><a href="#n283">283</a></p>
<p id="n284" class="stm mis"><a href="#n284">284</a></p>
<p id="n285" class="stm mis"><a href="#n285">285</a></p>
<p id="n286" class="pln"><a href="#n286">286</a></p>
<p id="n287" class="stm mis"><a href="#n287">287</a></p>
<p id="n288" class="pln"><a href="#n288">288</a></p>
<p id="n289" class="stm run hide_run"><a href="#n289">289</a></p>
<p id="n290" class="stm run hide_run"><a href="#n290">290</a></p>
<p id="n291" class="stm run hide_run"><a href="#n291">291</a></p>
<p id="n292" class="pln"><a href="#n292">292</a></p>
<p id="n293" class="stm run hide_run"><a href="#n293">293</a></p>
<p id="n294" class="stm run hide_run"><a href="#n294">294</a></p>
<p id="n295" class="stm run hide_run"><a href="#n295">295</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Author: Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#   RFC 1964 Partial Implementation</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#   RFC 4757 Partial Implementation</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#   RFC 4121 Partial Implementation</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#   RFC 3962 Partial Implementation</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t15" class="stm run hide_run"><span class="key">import</span> <span class="nam">struct</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="stm run hide_run"><span class="key">import</span> <span class="nam">random</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run"><span class="key">import</span> <span class="nam">string</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">from</span> <span class="nam">six</span> <span class="key">import</span> <span class="nam">b</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">Cryptodome</span><span class="op">.</span><span class="nam">Hash</span> <span class="key">import</span> <span class="nam">HMAC</span><span class="op">,</span> <span class="nam">MD5</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">from</span> <span class="nam">Cryptodome</span><span class="op">.</span><span class="nam">Cipher</span> <span class="key">import</span> <span class="nam">ARC4</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">structure</span> <span class="key">import</span> <span class="nam">Structure</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">krb5</span> <span class="key">import</span> <span class="nam">constants</span><span class="op">,</span> <span class="nam">crypto</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="com"># Our random number generator</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">    <span class="nam">rand</span> <span class="op">=</span> <span class="nam">random</span><span class="op">.</span><span class="nam">SystemRandom</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm mis"><span class="key">except</span> <span class="nam">NotImplementedError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">    <span class="nam">rand</span> <span class="op">=</span> <span class="nam">random</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">    <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln"><span class="com"># Constants</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm run hide_run"><span class="nam">GSS_C_DCE_STYLE</span>     <span class="op">=</span> <span class="num">0x1000</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run"><span class="nam">GSS_C_DELEG_FLAG</span>    <span class="op">=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run"><span class="nam">GSS_C_MUTUAL_FLAG</span>   <span class="op">=</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm run hide_run"><span class="nam">GSS_C_REPLAY_FLAG</span>   <span class="op">=</span> <span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run"><span class="nam">GSS_C_SEQUENCE_FLAG</span> <span class="op">=</span> <span class="num">8</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run"><span class="nam">GSS_C_CONF_FLAG</span>     <span class="op">=</span> <span class="num">0x10</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm run hide_run"><span class="nam">GSS_C_INTEG_FLAG</span>    <span class="op">=</span> <span class="num">0x20</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t42" class="pln"><span class="com"># Mic Semantics</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm run hide_run"><span class="nam">GSS_HMAC</span> <span class="op">=</span> <span class="num">0x11</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="com"># Wrap Semantics</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run"><span class="nam">GSS_RC4</span>  <span class="op">=</span> <span class="num">0x10</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="com"># 2.  Key Derivation for Per-Message Tokens</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run"><span class="nam">KG_USAGE_ACCEPTOR_SEAL</span>  <span class="op">=</span> <span class="num">22</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run"><span class="nam">KG_USAGE_ACCEPTOR_SIGN</span>  <span class="op">=</span> <span class="num">23</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm run hide_run"><span class="nam">KG_USAGE_INITIATOR_SEAL</span> <span class="op">=</span> <span class="num">24</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run"><span class="nam">KG_USAGE_INITIATOR_SIGN</span> <span class="op">=</span> <span class="num">25</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run"><span class="nam">KRB5_AP_REQ</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;H'</span><span class="op">,</span> <span class="num">0x1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="com"># 1.1.1. Initial Token - Checksum field</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm run hide_run"><span class="key">class</span> <span class="nam">CheckSumField</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln">        <span class="op">(</span><span class="str">'Lgth'</span><span class="op">,</span><span class="str">'&lt;L=16'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln">        <span class="op">(</span><span class="str">'Bnd'</span><span class="op">,</span><span class="str">'16s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln">        <span class="op">(</span><span class="str">'Flags'</span><span class="op">,</span><span class="str">'&lt;L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm run hide_run"><span class="key">def</span> <span class="nam">GSSAPI</span><span class="op">(</span><span class="nam">cipher</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm par run hide_run"><span class="annotate short">64&#x202F;&#x219B;&#x202F;65</span><span class="annotate long">line 64 didn't jump to line 65, because the condition on line 64 was never true</span>    <span class="key">if</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">enctype</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">EncryptionTypes</span><span class="op">.</span><span class="nam">aes256_cts_hmac_sha1_96</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">        <span class="key">return</span> <span class="nam">GSSAPI_AES256</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm par run hide_run"><span class="annotate short">66&#x202F;&#x219B;&#x202F;67</span><span class="annotate long">line 66 didn't jump to line 67, because the condition on line 66 was never true</span>    <span class="key">if</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">enctype</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">EncryptionTypes</span><span class="op">.</span><span class="nam">aes128_cts_hmac_sha1_96</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm mis">        <span class="key">return</span> <span class="nam">GSSAPI_AES128</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm par run hide_run"><span class="annotate short">68&#x202F;&#x219B;&#x202F;71</span><span class="annotate long">line 68 didn't jump to line 71, because the condition on line 68 was never false</span>    <span class="key">elif</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">enctype</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">EncryptionTypes</span><span class="op">.</span><span class="nam">rc4_hmac</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm run hide_run">        <span class="key">return</span> <span class="nam">GSSAPI_RC4</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">    <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">        <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">'Unsupported etype 0x%x'</span> <span class="op">%</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">enctype</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln"><span class="com"># 7.2.   GSS-API MIC Semantics</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run"><span class="key">class</span> <span class="nam">GSSAPI_RC4</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln">    <span class="com"># 1.2.1. Per-message Tokens - MIC</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm run hide_run">    <span class="key">class</span> <span class="nam">MIC</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run">        <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln">            <span class="op">(</span><span class="str">'TOK_ID'</span><span class="op">,</span><span class="str">'&lt;H=0x0101'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln">            <span class="op">(</span><span class="str">'SGN_ALG'</span><span class="op">,</span><span class="str">'&lt;H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln">            <span class="op">(</span><span class="str">'Filler'</span><span class="op">,</span><span class="str">'&lt;L=0xffffffff'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln">            <span class="op">(</span><span class="str">'SND_SEQ'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="pln">            <span class="op">(</span><span class="str">'SGN_CKSUM'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">        <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln">    <span class="com"># 1.2.2. Per-message Tokens - Wrap</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm run hide_run">    <span class="key">class</span> <span class="nam">WRAP</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="stm run hide_run">        <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="pln">            <span class="op">(</span><span class="str">'TOK_ID'</span><span class="op">,</span><span class="str">'&lt;H=0x0102'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln">            <span class="op">(</span><span class="str">'SGN_ALG'</span><span class="op">,</span><span class="str">'&lt;H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="pln">            <span class="op">(</span><span class="str">'SEAL_ALG'</span><span class="op">,</span><span class="str">'&lt;H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln">            <span class="op">(</span><span class="str">'Filler'</span><span class="op">,</span><span class="str">'&lt;H=0xffff'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">            <span class="op">(</span><span class="str">'SND_SEQ'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">            <span class="op">(</span><span class="str">'SGN_CKSUM'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln">            <span class="op">(</span><span class="str">'Confounder'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="pln">        <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GSS_GetMIC</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span> <span class="op">=</span> <span class="str">'init'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm run hide_run">        <span class="nam">GSS_GETMIC_HEADER</span> <span class="op">=</span> <span class="str">b'\x60\x23\x06\x09\x2a\x86\x48\x86\xf7\x12\x01\x02\x02'</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm run hide_run">        <span class="nam">token</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">MIC</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln">        <span class="com"># Let's pad the data</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm run hide_run">        <span class="nam">pad</span> <span class="op">=</span> <span class="op">(</span><span class="num">4</span> <span class="op">-</span> <span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span> <span class="op">%</span> <span class="num">4</span><span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0x3</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm run hide_run">        <span class="nam">padStr</span> <span class="op">=</span> <span class="nam">b</span><span class="op">(</span><span class="nam">chr</span><span class="op">(</span><span class="nam">pad</span><span class="op">)</span><span class="op">)</span> <span class="op">*</span> <span class="nam">pad</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm run hide_run">        <span class="nam">data</span> <span class="op">+=</span> <span class="nam">padStr</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_ALG'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">GSS_HMAC</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm par run hide_run"><span class="annotate short">107&#x202F;&#x219B;&#x202F;110</span><span class="annotate long">line 107 didn't jump to line 110, because the condition on line 107 was never false</span>        <span class="key">if</span> <span class="nam">direction</span> <span class="op">==</span> <span class="str">'init'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm run hide_run">            <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">)</span> <span class="op">+</span> <span class="str">b'\x00'</span><span class="op">*</span><span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm mis">            <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">)</span> <span class="op">+</span> <span class="str">b'\xff'</span><span class="op">*</span><span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t112" class="stm run hide_run">        <span class="nam">Ksign</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">.</span><span class="nam">contents</span><span class="op">,</span> <span class="str">b'signaturekey\0'</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="stm run hide_run">        <span class="nam">Sgn_Cksum</span> <span class="op">=</span> <span class="nam">MD5</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">15</span><span class="op">)</span> <span class="op">+</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span> <span class="op">+</span> <span class="nam">data</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm run hide_run">        <span class="nam">Sgn_Cksum</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Ksign</span><span class="op">,</span> <span class="nam">Sgn_Cksum</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_CKSUM'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">Sgn_Cksum</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm run hide_run">        <span class="nam">Kseq</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">.</span><span class="nam">contents</span><span class="op">,</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm run hide_run">        <span class="nam">Kseq</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kseq</span><span class="op">,</span> <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_CKSUM'</span><span class="op">]</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">ARC4</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kseq</span><span class="op">)</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm run hide_run">        <span class="nam">finalData</span> <span class="op">=</span> <span class="nam">GSS_GETMIC_HEADER</span> <span class="op">+</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm run hide_run">        <span class="key">return</span> <span class="nam">finalData</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GSS_Wrap</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span> <span class="op">=</span> <span class="str">'init'</span><span class="op">,</span> <span class="nam">encrypt</span><span class="op">=</span><span class="key">True</span><span class="op">,</span> <span class="nam">authData</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln">        <span class="com"># Damn inacurate RFC, useful info from here</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln">        <span class="com"># https://social.msdn.microsoft.com/Forums/en-US/fb98e8f4-e697-4652-bcb7-604e027e14cc/gsswrap-token-size-kerberos-and-rc4hmac?forum=os_windowsprotocols</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="pln">        <span class="com"># and here</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="pln">        <span class="com"># http://www.rfc-editor.org/errata_search.php?rfc=4757</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="stm run hide_run">        <span class="nam">GSS_WRAP_HEADER</span> <span class="op">=</span> <span class="str">b'\x60\x2b\x06\x09\x2a\x86\x48\x86\xf7\x12\x01\x02\x02'</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="stm run hide_run">        <span class="nam">token</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t131" class="pln">        <span class="com"># Let's pad the data</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm run hide_run">        <span class="nam">pad</span> <span class="op">=</span> <span class="op">(</span><span class="num">8</span> <span class="op">-</span> <span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span> <span class="op">%</span> <span class="num">8</span><span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0x7</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="stm run hide_run">        <span class="nam">padStr</span> <span class="op">=</span> <span class="nam">b</span><span class="op">(</span><span class="nam">chr</span><span class="op">(</span><span class="nam">pad</span><span class="op">)</span><span class="op">)</span> <span class="op">*</span> <span class="nam">pad</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm run hide_run">        <span class="nam">data</span> <span class="op">+=</span> <span class="nam">padStr</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_ALG'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">GSS_HMAC</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SEAL_ALG'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">GSS_RC4</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm par run hide_run"><span class="annotate short">139&#x202F;&#x219B;&#x202F;142</span><span class="annotate long">line 139 didn't jump to line 142, because the condition on line 139 was never false</span>        <span class="key">if</span> <span class="nam">direction</span> <span class="op">==</span> <span class="str">'init'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="stm run hide_run">            <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">)</span> <span class="op">+</span> <span class="str">b'\x00'</span><span class="op">*</span><span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm mis">            <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">)</span> <span class="op">+</span> <span class="str">b'\xff'</span><span class="op">*</span><span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t144" class="pln">        <span class="com"># Random confounder :)</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'Confounder'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">b</span><span class="op">(</span><span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="op">[</span><span class="nam">rand</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_letters</span><span class="op">)</span> <span class="key">for</span> <span class="nam">_</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">8</span><span class="op">)</span><span class="op">]</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t147" class="stm run hide_run">        <span class="nam">Ksign</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">.</span><span class="nam">contents</span><span class="op">,</span> <span class="str">b'signaturekey\0'</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm run hide_run">        <span class="nam">Sgn_Cksum</span> <span class="op">=</span> <span class="nam">MD5</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">13</span><span class="op">)</span> <span class="op">+</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'Confounder'</span><span class="op">]</span> <span class="op">+</span> <span class="nam">data</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm run hide_run">        <span class="nam">Klocal</span> <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="stm run hide_run">        <span class="key">from</span> <span class="nam">builtins</span> <span class="key">import</span> <span class="nam">bytes</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm run hide_run">        <span class="key">for</span> <span class="nam">n</span> <span class="key">in</span> <span class="nam">bytes</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">.</span><span class="nam">contents</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm run hide_run">            <span class="nam">Klocal</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">n</span> <span class="op">^</span> <span class="num">0xF0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm run hide_run">        <span class="nam">Kcrypt</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Klocal</span><span class="op">,</span><span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="stm run hide_run">        <span class="nam">Kcrypt</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kcrypt</span><span class="op">,</span><span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">)</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t158" class="stm run hide_run">        <span class="nam">Sgn_Cksum</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Ksign</span><span class="op">,</span> <span class="nam">Sgn_Cksum</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t159" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_CKSUM'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">Sgn_Cksum</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t162" class="stm run hide_run">        <span class="nam">Kseq</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">.</span><span class="nam">contents</span><span class="op">,</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm run hide_run">        <span class="nam">Kseq</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kseq</span><span class="op">,</span> <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_CKSUM'</span><span class="op">]</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t165" class="stm run hide_run">        <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">ARC4</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kseq</span><span class="op">)</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t167" class="stm run hide_run">        <span class="key">if</span> <span class="nam">authData</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t168" class="stm run hide_run">            <span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">rpcrt</span> <span class="key">import</span> <span class="nam">SEC_TRAILER</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm run hide_run">            <span class="nam">wrap</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="nam">authData</span><span class="op">[</span><span class="nam">len</span><span class="op">(</span><span class="nam">SEC_TRAILER</span><span class="op">(</span><span class="op">)</span><span class="op">)</span> <span class="op">+</span> <span class="nam">len</span><span class="op">(</span><span class="nam">GSS_WRAP_HEADER</span><span class="op">)</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="stm run hide_run">            <span class="nam">snd_seq</span> <span class="op">=</span> <span class="nam">wrap</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t172" class="stm run hide_run">            <span class="nam">Kseq</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">.</span><span class="nam">contents</span><span class="op">,</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t173" class="stm run hide_run">            <span class="nam">Kseq</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kseq</span><span class="op">,</span> <span class="nam">wrap</span><span class="op">[</span><span class="str">'SGN_CKSUM'</span><span class="op">]</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t175" class="stm run hide_run">            <span class="nam">snd_seq</span> <span class="op">=</span> <span class="nam">ARC4</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kseq</span><span class="op">)</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">wrap</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm run hide_run">            <span class="nam">Kcrypt</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Klocal</span><span class="op">,</span><span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;L'</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="stm run hide_run">            <span class="nam">Kcrypt</span> <span class="op">=</span> <span class="nam">HMAC</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kcrypt</span><span class="op">,</span><span class="nam">snd_seq</span><span class="op">[</span><span class="op">:</span><span class="num">4</span><span class="op">]</span><span class="op">,</span> <span class="nam">MD5</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="stm run hide_run">            <span class="nam">rc4</span> <span class="op">=</span> <span class="nam">ARC4</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kcrypt</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t180" class="stm run hide_run">            <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">rc4</span><span class="op">.</span><span class="nam">decrypt</span><span class="op">(</span><span class="nam">token</span><span class="op">[</span><span class="str">'Confounder'</span><span class="op">]</span> <span class="op">+</span> <span class="nam">data</span><span class="op">)</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="stm par run hide_run"><span class="annotate short">181&#x202F;&#x219B;&#x202F;186</span><span class="annotate long">line 181 didn't jump to line 186, because the condition on line 181 was never false</span>        <span class="key">elif</span> <span class="nam">encrypt</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t182" class="stm run hide_run">            <span class="nam">rc4</span> <span class="op">=</span> <span class="nam">ARC4</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Kcrypt</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="stm run hide_run">            <span class="nam">token</span><span class="op">[</span><span class="str">'Confounder'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">rc4</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">token</span><span class="op">[</span><span class="str">'Confounder'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="stm run hide_run">            <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">rc4</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t186" class="stm mis">            <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t188" class="stm run hide_run">        <span class="nam">finalData</span> <span class="op">=</span> <span class="nam">GSS_WRAP_HEADER</span> <span class="op">+</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="stm run hide_run">        <span class="key">return</span> <span class="nam">cipherText</span><span class="op">,</span> <span class="nam">finalData</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t191" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GSS_Unwrap</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span> <span class="op">=</span> <span class="str">'init'</span><span class="op">,</span> <span class="nam">encrypt</span><span class="op">=</span><span class="key">True</span><span class="op">,</span> <span class="nam">authData</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t192" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">GSS_Wrap</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span><span class="op">,</span> <span class="nam">encrypt</span><span class="op">,</span> <span class="nam">authData</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t193" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t194" class="stm run hide_run"><span class="key">class</span> <span class="nam">GSSAPI_AES</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm run hide_run">    <span class="nam">checkSumProfile</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="stm run hide_run">    <span class="nam">cipherType</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t198" class="stm run hide_run">    <span class="key">class</span> <span class="nam">MIC</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="stm run hide_run">        <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="pln">            <span class="op">(</span><span class="str">'TOK_ID'</span><span class="op">,</span><span class="str">'>H=0x0404'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t201" class="pln">            <span class="op">(</span><span class="str">'Flags'</span><span class="op">,</span><span class="str">'B=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="pln">            <span class="op">(</span><span class="str">'Filler0'</span><span class="op">,</span><span class="str">'B=0xff'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t203" class="pln">            <span class="op">(</span><span class="str">'Filler'</span><span class="op">,</span><span class="str">'>L=0xffffffff'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t204" class="pln">            <span class="op">(</span><span class="str">'SND_SEQ'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t205" class="pln">            <span class="op">(</span><span class="str">'SGN_CKSUM'</span><span class="op">,</span><span class="str">'12s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t206" class="pln">        <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t207" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t208" class="pln">    <span class="com"># 1.2.2. Per-message Tokens - Wrap</span><span class="strut">&nbsp;</span></p>
<p id="t209" class="stm run hide_run">    <span class="key">class</span> <span class="nam">WRAP</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t210" class="stm run hide_run">        <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t211" class="pln">            <span class="op">(</span><span class="str">'TOK_ID'</span><span class="op">,</span><span class="str">'>H=0x0504'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t212" class="pln">            <span class="op">(</span><span class="str">'Flags'</span><span class="op">,</span><span class="str">'B=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t213" class="pln">            <span class="op">(</span><span class="str">'Filler'</span><span class="op">,</span><span class="str">'B=0xff'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t214" class="pln">            <span class="op">(</span><span class="str">'EC'</span><span class="op">,</span><span class="str">'>H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t215" class="pln">            <span class="op">(</span><span class="str">'RRC'</span><span class="op">,</span><span class="str">'>H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t216" class="pln">            <span class="op">(</span><span class="str">'SND_SEQ'</span><span class="op">,</span><span class="str">'8s=b""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t217" class="pln">        <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t218" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t219" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GSS_GetMIC</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span> <span class="op">=</span> <span class="str">'init'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t220" class="stm mis">        <span class="nam">token</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">MIC</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t221" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t222" class="pln">        <span class="com"># Let's pad the data</span><span class="strut">&nbsp;</span></p>
<p id="t223" class="stm mis">        <span class="nam">pad</span> <span class="op">=</span> <span class="op">(</span><span class="num">4</span> <span class="op">-</span> <span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span> <span class="op">%</span> <span class="num">4</span><span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0x3</span><span class="strut">&nbsp;</span></p>
<p id="t224" class="stm mis">        <span class="nam">padStr</span> <span class="op">=</span> <span class="nam">chr</span><span class="op">(</span><span class="nam">pad</span><span class="op">)</span> <span class="op">*</span> <span class="nam">pad</span><span class="strut">&nbsp;</span></p>
<p id="t225" class="stm mis">        <span class="nam">data</span> <span class="op">+=</span> <span class="nam">padStr</span><span class="strut">&nbsp;</span></p>
<p id="t226" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t227" class="stm mis">        <span class="nam">checkSumProfile</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">checkSumProfile</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t228" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t229" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'Flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t230" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>Q'</span><span class="op">,</span><span class="nam">sequenceNumber</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t231" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'SGN_CKSUM'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">checkSumProfile</span><span class="op">.</span><span class="nam">checksum</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">KG_USAGE_INITIATOR_SIGN</span><span class="op">,</span> <span class="nam">data</span> <span class="op">+</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="op">[</span><span class="op">:</span><span class="num">16</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t232" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t233" class="stm mis">        <span class="key">return</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t234" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t235" class="stm run hide_run">    <span class="key">def</span> <span class="nam">rotate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">numBytes</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t236" class="stm mis">        <span class="nam">numBytes</span> <span class="op">%=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t237" class="stm mis">        <span class="nam">left</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span> <span class="op">-</span> <span class="nam">numBytes</span><span class="strut">&nbsp;</span></p>
<p id="t238" class="stm mis">        <span class="nam">result</span> <span class="op">=</span> <span class="nam">data</span><span class="op">[</span><span class="nam">left</span><span class="op">:</span><span class="op">]</span> <span class="op">+</span> <span class="nam">data</span><span class="op">[</span><span class="op">:</span><span class="nam">left</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t239" class="stm mis">        <span class="key">return</span> <span class="nam">result</span><span class="strut">&nbsp;</span></p>
<p id="t240" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t241" class="stm run hide_run">    <span class="key">def</span> <span class="nam">unrotate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">numBytes</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t242" class="stm mis">        <span class="nam">numBytes</span> <span class="op">%=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t243" class="stm mis">        <span class="nam">result</span> <span class="op">=</span> <span class="nam">data</span><span class="op">[</span><span class="nam">numBytes</span><span class="op">:</span><span class="op">]</span> <span class="op">+</span> <span class="nam">data</span><span class="op">[</span><span class="op">:</span><span class="nam">numBytes</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t244" class="stm mis">        <span class="key">return</span> <span class="nam">result</span><span class="strut">&nbsp;</span></p>
<p id="t245" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t246" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GSS_Wrap</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span> <span class="op">=</span> <span class="str">'init'</span><span class="op">,</span> <span class="nam">encrypt</span><span class="op">=</span><span class="key">True</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t247" class="stm mis">        <span class="nam">token</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t248" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t249" class="stm mis">        <span class="nam">cipher</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">cipherType</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t250" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t251" class="pln">        <span class="com"># Let's pad the data</span><span class="strut">&nbsp;</span></p>
<p id="t252" class="stm mis">        <span class="nam">pad</span> <span class="op">=</span> <span class="op">(</span><span class="nam">cipher</span><span class="op">.</span><span class="nam">blocksize</span> <span class="op">-</span> <span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span> <span class="op">%</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">blocksize</span><span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">15</span><span class="strut">&nbsp;</span></p>
<p id="t253" class="stm mis">        <span class="nam">padStr</span> <span class="op">=</span> <span class="str">b'\xFF'</span> <span class="op">*</span> <span class="nam">pad</span><span class="strut">&nbsp;</span></p>
<p id="t254" class="stm mis">        <span class="nam">data</span> <span class="op">+=</span> <span class="nam">padStr</span><span class="strut">&nbsp;</span></p>
<p id="t255" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t256" class="pln">        <span class="com"># The RRC field ([RFC4121] section 4.2.5) is 12 if no encryption is requested or 28 if encryption </span><span class="strut">&nbsp;</span></p>
<p id="t257" class="pln">        <span class="com"># is requested. The RRC field is chosen such that all the data can be encrypted in place.</span><span class="strut">&nbsp;</span></p>
<p id="t258" class="stm mis">        <span class="nam">rrc</span> <span class="op">=</span> <span class="num">28</span><span class="strut">&nbsp;</span></p>
<p id="t259" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t260" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'Flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">6</span><span class="strut">&nbsp;</span></p>
<p id="t261" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'EC'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">pad</span><span class="strut">&nbsp;</span></p>
<p id="t262" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'RRC'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t263" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'SND_SEQ'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>Q'</span><span class="op">,</span><span class="nam">sequenceNumber</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t264" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t265" class="stm mis">        <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">KG_USAGE_INITIATOR_SEAL</span><span class="op">,</span>  <span class="nam">data</span> <span class="op">+</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="key">None</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t266" class="stm mis">        <span class="nam">token</span><span class="op">[</span><span class="str">'RRC'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">rrc</span><span class="strut">&nbsp;</span></p>
<p id="t267" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t268" class="stm mis">        <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">rotate</span><span class="op">(</span><span class="nam">cipherText</span><span class="op">,</span> <span class="nam">token</span><span class="op">[</span><span class="str">'RRC'</span><span class="op">]</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'EC'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t269" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t270" class="pln">        <span class="com">#nn = self.unrotate(cipherText, token['RRC'] + token['EC'])</span><span class="strut">&nbsp;</span></p>
<p id="t271" class="stm mis">        <span class="nam">ret1</span> <span class="op">=</span> <span class="nam">cipherText</span><span class="op">[</span><span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="op">)</span><span class="op">)</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'RRC'</span><span class="op">]</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'EC'</span><span class="op">]</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t272" class="stm mis">        <span class="nam">ret2</span> <span class="op">=</span> <span class="nam">token</span><span class="op">.</span><span class="nam">getData</span><span class="op">(</span><span class="op">)</span> <span class="op">+</span> <span class="nam">cipherText</span><span class="op">[</span><span class="op">:</span><span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="op">)</span><span class="op">)</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'RRC'</span><span class="op">]</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'EC'</span><span class="op">]</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t273" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t274" class="stm mis">        <span class="key">return</span> <span class="nam">ret1</span><span class="op">,</span> <span class="nam">ret2</span><span class="strut">&nbsp;</span></p>
<p id="t275" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t276" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GSS_Unwrap</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">sequenceNumber</span><span class="op">,</span> <span class="nam">direction</span> <span class="op">=</span> <span class="str">'init'</span><span class="op">,</span> <span class="nam">encrypt</span><span class="op">=</span><span class="key">True</span><span class="op">,</span> <span class="nam">authData</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t277" class="stm mis">        <span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">rpcrt</span> <span class="key">import</span> <span class="nam">SEC_TRAILER</span><span class="strut">&nbsp;</span></p>
<p id="t278" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t279" class="stm mis">        <span class="nam">cipher</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">cipherType</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t280" class="stm mis">        <span class="nam">token</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="nam">authData</span><span class="op">[</span><span class="nam">len</span><span class="op">(</span><span class="nam">SEC_TRAILER</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t281" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t282" class="stm mis">        <span class="nam">rotated</span> <span class="op">=</span> <span class="nam">authData</span><span class="op">[</span><span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">+</span><span class="nam">len</span><span class="op">(</span><span class="nam">SEC_TRAILER</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="op">]</span> <span class="op">+</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t283" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t284" class="stm mis">        <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">unrotate</span><span class="op">(</span><span class="nam">rotated</span><span class="op">,</span> <span class="nam">token</span><span class="op">[</span><span class="str">'RRC'</span><span class="op">]</span> <span class="op">+</span> <span class="nam">token</span><span class="op">[</span><span class="str">'EC'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t285" class="stm mis">        <span class="nam">plainText</span> <span class="op">=</span> <span class="nam">cipher</span><span class="op">.</span><span class="nam">decrypt</span><span class="op">(</span><span class="nam">sessionKey</span><span class="op">,</span> <span class="nam">KG_USAGE_ACCEPTOR_SEAL</span><span class="op">,</span>  <span class="nam">cipherText</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t286" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t287" class="stm mis">        <span class="key">return</span> <span class="nam">plainText</span><span class="op">[</span><span class="op">:</span><span class="op">-</span><span class="op">(</span><span class="nam">token</span><span class="op">[</span><span class="str">'EC'</span><span class="op">]</span><span class="op">+</span><span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">WRAP</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="op">]</span><span class="op">,</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t288" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t289" class="stm run hide_run"><span class="key">class</span> <span class="nam">GSSAPI_AES256</span><span class="op">(</span><span class="nam">GSSAPI_AES</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t290" class="stm run hide_run">    <span class="nam">checkSumProfile</span> <span class="op">=</span> <span class="nam">crypto</span><span class="op">.</span><span class="nam">_SHA1AES256</span><span class="strut">&nbsp;</span></p>
<p id="t291" class="stm run hide_run">    <span class="nam">cipherType</span> <span class="op">=</span> <span class="nam">crypto</span><span class="op">.</span><span class="nam">_AES256CTS</span><span class="strut">&nbsp;</span></p>
<p id="t292" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t293" class="stm run hide_run"><span class="key">class</span> <span class="nam">GSSAPI_AES128</span><span class="op">(</span><span class="nam">GSSAPI_AES</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t294" class="stm run hide_run">    <span class="nam">checkSumProfile</span> <span class="op">=</span> <span class="nam">crypto</span><span class="op">.</span><span class="nam">_SHA1AES128</span><span class="strut">&nbsp;</span></p>
<p id="t295" class="stm run hide_run">    <span class="nam">cipherType</span> <span class="op">=</span> <span class="nam">crypto</span><span class="op">.</span><span class="nam">_AES128CTS</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
